



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>deeplearning.ai学习seq2seq模型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">deeplearning.ai学习seq2seq模型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:44:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、seq2seq架构图</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411095112257-373679066.png" /></p>
<p>seq2seq模型左边绿色的部分我们称之为encoder，左边的循环输入最终生成一个固定向量作为右侧的输入，右边紫色的部分我们称之为decoder。单看右侧这个结构跟我们之前学习的语言模型非常相似，如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411095353264-1069952471.png" /></p>
<p>唯一不同的是，语言模型的输入a&lt;0&gt;是一个零向量，而seq2seq模型decoder部分的输入是由encoder编码得到的一个固定向量。所以可以称seq2seq模型为<strong>条件语言模型p(y|x)。</strong></p>
<p>语言模型生成的序列y是可以随机生成的，而seq2seq模型用于到机器翻译中，我们是要找到概率最大的序列y，即最可能或者说最好的翻译结果，<strong>max p(y|x)。</strong></p>
<p><strong>seq2seq模型如何寻找到最可能的序列y呢？</strong></p>
<p>是不是可以采用贪心算法呢？如果采用贪心算法找的结果不一定是最优的，只能说是其中一个结果。因为贪心算法的思路是先找到第一个最好的y&lt;1&gt;,第一个输出结果y&lt;1&gt;再找到第二个最好的y&lt;2&gt;，以此类推。这种方式的最终结果是每一个元素可能是最优的，但是整个句子却未必是最好的。例如下面的句子：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411100212365-1072036798.png" /></p>
<p>采用贪心算法，最可能的结果就是第二句，因为如果前两个是Jane is ，第三个最可能的是going，而不是visiting，这是因为is going在英语中大量存在。但是最好的结果却是第一个句子。</p>
<p><strong>二、beam search(集束搜索)</strong></p>
<p>还是以上述机器翻译的例子来解释集束搜索算法流程，<strong>第一步如下</strong>：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411111027464-2075080497.png" /></p>
<p>第一步就是先根据左侧的输入，生成第一个输出y&lt;1&gt;，y&lt;1&gt;是softmax转换后的概率输出。集束搜索需要设置集束宽度，本次设置B(beam width)=3，也就是每次仅保留概率最大的top3个。所以，第一步就是选择y&lt;1&gt;中概率最大的前三个词，假设本例子中是<strong>in，jane，september</strong>，就保留这三个词在内存中。</p>
<p><strong>第二步：</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411111607947-1367926105.png" /></p>
<p>第二步就是在y&lt;1&gt;为in，jane，September的情况下，分别计算第二个词的概率，如上图所示套入三个seq2seq模型中去各自寻找。因为词典维度|v|=10000，所以三个词最终会计算出30000个后面衔接第二个词的概率，最终从这30000个里面选出概率最大的top3个即可，因为集束宽度依然为3。假设第二步筛选出来的结果是i<strong>n september， jane is，jane visits；</strong>September开头的因为连接后面的词后概率偏低，已经被去掉了<strong>。</strong></p>
<p><strong>第三步：</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411112021893-275340360.png" /></p>
<p>第三步其实是跟第二步一样，直到最后选出EOS结束。</p>
<p><strong>三、beam search的优化</strong></p>
<p><strong>优化一：</strong></p>
<p>将概率的乘积转化成为概率的对数求和。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411142157901-697926670.png" /></p>
<p>因为乘积的话，会越乘越小，甚至会导致数值的下溢问题。取对数后就变成了连加，就基本解决了这个问题，而且对数后的目标函数与原目标函数解是一致的。</p>
<p><strong>优化二：</strong></p>
<p>归一化目标函数，除以翻译结果的单词数量，减少了对长的结果的惩罚。因为从上述目标函数可以看出，无论原目标函数还是对数目标函数，都不利于长的结果的输出，因为结果越长，连乘或者连加(每个元素取对数后都是负数)都使得概率越来越小。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1102791/201904/1102791-20190411142903631-705023125.png" /></p>
<p>这里的<strong>T<sub>y</sub></strong>就是翻译结果的单词数量，&alpha;是一个超参数，可以设置0（相当于不做归一化），0.7，1，需要根据实际情况调整得到一个最优的结果。</p>
<p><strong>集束宽度B的选择：</strong></p>
<p>large B：效果好，计算代价大，运行慢。</p>
<p>small B：效果差，计算代价小，运行快。</p>
<p>工业中，B=10，往往是一个不错的选择；科研中，为了充分实验，可以尝试100,1000,3000.</p>
<p>B从1~10，性能提升比较明显，但是B从1000~3000，提升就没有那么明显了。</p>
<p>总结，相比于BFS(广度优先搜索)、DFS，beam search不能保证一定能找到arg max 的准确最大值，是一个近似的最大值。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ge7zq.html">机器学习 1 linear regression 作业&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1jwk2q.html">webservice 实现json模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jy5e09.html">Python模块&lpar;pickle&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jzv28.html">c&num;部分---网吧充值系统；简易的闹钟；出租车计费；简单计算器；对战游戏；等额本金法计算贷款还款利息等；随机生成10个不重复的50以内的整数；推箱子；</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2xr29.html">Java条形码生成方案及二维码要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdpdw49.html">Python第一天&mdash;&mdash;入门Python&lpar;4&rpar;字典的常用操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpzegzq.html">对java面向对象的初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5loj8.html">Python Generator 运行细节验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgvvpd8.html">history&period;pushState&lpar;&rpar;和history&period;replaceState&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25dxdlq.html">1、docker容器技术基础入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1ey6q.html">Linux的安装以及部署一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3oo49.html">BZOJ 2839&colon; 集合计数 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllp5y6q.html">Springboot学习05-自定义错误页面完整分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1epz19.html">POJ1159</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlvzwk9.html">java php 等，路径 上级路径，上上级路径表示方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjry628.html">Fiddler 抓包浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pe7veq.html">第二百六十三节，Tornado框架-基于正则的动态路由映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odn4eeq.html">SQL Server语句创建数据库和表&mdash;&mdash;并设置主外键关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xgwlo9.html">quartz 使用配置文件配置线程数</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pz6kvq.html">H5 中html 页面存为图片并长按 保存</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdj0y1xq.html">【SE】Week7 &colon; Silver Bullet &amp;amp&semi; Cathedral and Bazaar &amp;amp&semi; Big Ball of Mud &amp;amp&semi; Waterfall &period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/963j1gj9.html">git 客户端连接gitlab 实现简单的CI&sol;CD</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj0myxq.html">Navicat Premium和Navicat for MySQL哪个好用&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1mee69.html">深入理解ajax系列第八篇&mdash;&mdash;表单提交</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdje0r0q.html">c&plus;&plus;&sol; boost 库常见错误及解决方法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvddydq.html">Mouse Hunt CodeForces - 1027D&lpar;思维 找环&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwldd5l9.html">51Nod 1199 Money out of Thin Air （树链剖分&plus;线段树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlddzz9.html">c&plus;&plus;11 基于范围的for循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpmp279.html">springcloud与dubbo对比：</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2nlne8.html">eos源码剖析之controller</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
